/**
 * A 2D land where the thief and the police are located in
 */
public class Land {
    private int length;
    private int width;
    private char[][] landMatrix;

    /**
     * Constructor
     * @param length specifies length of this land
     * @param width specifies width of this land
     */
    public Land(int length, int width) {
        this.length = length;
        this.width = width;
        landMatrix = new char[length][width];
    }

    /**
     * @return length of length
     */
    public int getLength() {
        return length;
    }

    /**
     * @return width of length
     */

    public int getWidth() {
        return width;
    }

    /**
     * Sets an element of this 2D array land
     * @param x is the x coordinate of element
     * @param y is the y coordinate of element
     * @param c is the substitute value of the element
     */
    public void setLandMatrix(int x, int y, char c){
        if(x>=0 && x<width && y>=0 && y<length) {
            landMatrix[x][y] = c;
        }
    }

    /**
     * @return value of 2D array land in x , y coordinate
     */

    public  char getLandMatrix(int x,int y) {
        return landMatrix[x][y];
    }

}
